' PdfNameB.VBS V1.00 (C) yoshioka.teruo@nifty.com 2003-10-03
' PdfNameB.VBS renames pdffile to "yyyymmdd title.pdf"
' Usage: start pdfnameb.vbs pdfiles...

Option Explicit

Wscript.Quit Main()

Function Main()
Dim wShell
Dim fso
Dim arg
Dim fa
Dim ext
Dim fname
Dim ans
Dim file
Dim line
Dim Title
Dim ModDate
Dim CreationDate
Dim n
Dim i
Dim s
Dim stdout

Dim CProp
  CProp=Array("/Title ","/ModDate ","/CreationDate ",_
              "/Subject ","/Author ","/Creator ","/Producer ",_
              "/Keywords ","/Thumbnails ","/SavedBy ")

Dim LMin
    LMin=10

Dim LProp()
Dim BProp()
ReDim LProp(UBound(CProp))
ReDim BProp(UBound(CProp))
  For n=0 To UBound(CProp)
    LProp(n)=Len(CProp(n))
    If LProp(i)<LMin Then LMin=LProp(i)
    BProp(n)=String2Bytes(CProp(n))
  Next

Set wShell=CreateObject("Wscript.Shell")
Set fso=CreateObject("Scripting.FileSystemObject")

If Ucase(fso.GetBaseName(Wscript.FullName))="CSCRIPT" Then
  Set stdout=WScript.StdOut
End If

For Each arg In Wscript.Arguments
  Set fa=fso.GetFile(arg)
  ext=fso.GetExtensionName(fa.Name)
  Select Case Ucase(ext)
    Case "PDF"
    Case Else
      Wscript.Echo "Unknown Extension Name: "  & ext & vbCrLf & fa.Name
      Wscript.Quit
  End Select

  Set file=New BinaryStream
  file.Open(fa.Path)
  file.EOLchar=Asc(vbCR)

Dim Prop()
  ReDim Prop(UBound(CProp))

  Prop(0)=Array()
  Prop(1)=Array()
  Prop(2)=Array()

  line=file.Read(4)
  If line(0)=Asc("%") And line(1)=Asc("P") And _
     line(2)=Asc("D")  And line(3)=Asc("F") Then
  ElseIf line(0)=Asc("P") And line(1)=Asc("%") And _
     line(2)=Asc("F")  And line(3)=Asc("D") Then
    file.Close
    file.Open(fa.Path)
    file.EOLchar=Asc(vbCR)
    file.BigEndian=True
  Else
    Wscript.Echo fa.Name & vbCrLf & ": is Not PDF File."
    Wscript.Quit
  End If

  Dim prev
  prev=Array()
  Do While Not file.AtEndOfStream
    line=file.ReadLine()
    If UBound(prev)>=0 Then
'      WScript.Echo "continueing",UBound(prev),UBound(line)
      line=CatBytes(prev,line)
'      WScript.Echo "continued",UBound(line)
      prev=Array()
    End If
    n=UBound(line)
    If n>2 Then
      If line(n-1)=Asc("\") Then
        If line(n)=Asc(vbCR) Then
          prev=MidBytes(line,0,n+1-2)
'         WScript.Echo "to be continued",UBound(line),UBound(prev)
          line=Array()
          n=-1
        End If
      End If
    End If
    If n>LMin Then ' n+1>=(LMin + "(" + "?" )
      If line(0)=&H2F Then 'Asc("/")
        If line(n)=Asc(vbCR) Then n=n-1
        If line(n)=Asc(")") Then n=n-1
        For i=0 To UBound(CProp)
          If i=3 Then If IsEmpty(stdout) Then Exit For
          If n>=LProp(i) Then ' n+1>=(LProp(i) + "(" )
            If BytesComp(line,0,BProp(i),0,LProp(i))=0 Then
              If line(LProp(i))=Asc("(") Then
                s=1
              ElseIf line(LProp(i))=Asc("<") Then
                s=0
              Else
                Exit For
              End If
              Prop(i)=MidBytes(line,LProp(i)+s,n+1-LProp(i)-s)
              If Not IsEmpty(stdout) Then stdout.Write CProp(i) & "(" & Bytes2sjis(Prop(i)) & ")" & vbCRLF
              Exit For
            End If
          End If
        Next
      End If
    End If
  Loop
  file.Close

  ModDate=Prop(1)
  CreationDate=Prop(2)
  Title=bytes2sjis(Prop(0))

  If Title<>"" Then
    If Not IsEmpty(stdout) Then stdout.Write CProp(0) & "(" & Title & ")" & vbCRLF
  End If

  If UBound(ModDate)<0 Then
    ModDate=CreationDate
  End If
  If UBound(ModDate)>=0 Then
    ModDate=Bytes2String(modDate,0,0)
  End If
  If IsArray(ModDate) Then
    ModDate=""
  Else
    If Not IsEmpty(stdout) Then stdout.Write CProp(1) & "(" & ModDate & ")" & vbCRLF
  End If

' Wscript.Quit

  If IsEmpty(stdout) Then

    If Title<>"" Then
      Title=Replace(Title,"/","%")
      Title=Replace(Title,":","=")
    End If

    If ModDate<>"" Then
      If Left(ModDate,2)="D:" Then
        ModDate=Mid(ModDate,3,8) & " "
      End If
    End If

    fname=ModDate & Title & "." & ext
    ans=InputBox("Enter New Name",fa.Name,fname)
    n=1
    Do While ans<>""
      Call Rename(fa,ans)
      If err=0 Then
        ans=""
      ElseIf err=58 Then
        n=n+1
        fname=ModDate & Title & " " & n & "." & ext
        ans=InputBox(err.Number & ":" & err.Description & "Re-Enter New Name",faame,fname)
      Else
        ans=InputBox(err.Number & ":" & err.Description & "Re-Enter New Name",fa.Name,fname)
      End If
    Loop
  End If
Next
End Function

Sub Rename(fa,ans)
  On Error Resume Next
  fa.Name=ans
End Sub

Function hex2sjis(str)
  Dim n,i
  Dim c

  n=Len(str)
  i=1
  hex2sjis=""
  Do While i<n
    c=CLng("&H" & Mid(str,i,2))
    If ((129<=c) And (c<=159)) Or ((224<=c) And (c<=239)) Then
      hex2sjis=hex2sjis & Chr(CLng("&H" & Mid(str,i,4)))
      i=i+4
    Else
      hex2sjis=hex2sjis & Chr(c)
      i=i+2
    End If
  Loop
End Function

Function huc2sjis(str)
  Dim i

  For i=1 To Len(str)-3 Step 4
      huc2sjis=huc2sjis & UnEscape("%u" & Mid(str,i,4))
  Next
End Function

Function ucs2sjis(a,s,n)
  Dim m,i
  If n>0 Then
    m=n
  Else
    m=UBound(a)-s+1
  End If
  For i=0 To m-2 Step 2
    ucs2sjis=ucs2sjis & ChrW(a(s+i)*256+a(s+i+1))
  Next
End Function

Function BytesComp(s,si,d,di,n)
  Dim i
  For i=0 To n-1
    BytesComp=s(si+i)-d(di+i)
    If BytesComp<>0 Then Exit For
  Next
End Function

Function Bytes2sjis(a)
Dim BUniCode
    BUniCode=Array(254,255)

Dim LUniCode
    LUniCode=2

  Dim r,n
  If UBound(a)>0 Then
    If BytesComp(a,0,BUniCode,0,LUniCode)=0 Then
      r=ucs2sjis(a,2,0)
    End If
  End If
  If IsEmpty(r) Then
    If UBound(a)>=0 Then
      r=Bytes2String(a,0,0)
    End If
  End If
  n=Len(r)
  If n>0 Then
    If Left(r,8)="\376\377" Then
      r=ouc2sjis(Mid(r,9,n-8))
    ElseIf Left(r,5)="<FEFF" And Right(r,1)=">" Then
      r=huc2sjis(Mid(r,6,n-6))
    ElseIf Left(r,1)="<" And Right(r,1)=">" Then
      r=hex2sjis(Mid(r,2,n-2))
    End If
  End If
  Bytes2sjis=r
End Function

Function ouc2sjis(s)
  Dim i,u,m,n

  i=1
  u=0
  m=0
  n=Len(s)
  Do While i<n
    If Mid(s,i,2)="\(" Or Mid(s,i,2)="\)" Then
      u=u*256+Asc(Mid(s,i+1,1))
      i=i+2
    ElseIf Mid(s,i,1)="\" Then
'      wscript.echo Mid(s,i+1,3)
      u=u*256+CLng("&O" & Mid(s,i+1,3))
      i=i+4
    Else
      u=u*256+Asc(Mid(s,i,1))
      i=i+1
    End If
    m=m+1
    If m=2 Then
'      wscript.echo u
      ouc2sjis=ouc2sjis & ChrW(u)
      u=0
      m=0
    End If
  Loop
End Function

Class BinaryStream
  Public EOLchar
  Public EOLchop
  Public Mandatory
  Public BigEndian
  
  Private fso
  Private file
  Private bufBytes
  Private bufLeft

Private Sub Class_Initialize()
  EOLchar=Asc(vbLF)
  EOLchop=False
  Mandatory=False
End Sub

Function Open(path)
  Dim bufb(2047)

  Set fso=CreateObject("Scripting.FileSystemObject")
  Set file=fso.OpenTextFile(path,1,,-1)
  bufBytes=bufb
  bufLeft=0
  BigEndian=False
End Function

Function AtEndOfStream()
  If bufLeft=0 Then
    AtEndOfStream=file.AtEndOfStream
  Else
    AtEndOfStream=False
  End If
End Function

Private Function FilBuf()
  Dim buf
  Dim n
  Dim c,w

  buf=file.Read(1024)
  If BigEndian Then
    For n=Len(buf) To 1 Step -1
      c=Mid(buf,n,1)
      w=AscW(c)
      If w<0 Then
        w=w+256*256
      End If
      bufBytes(bufLeft)=w mod 256
      bufLeft=bufLeft+1
      bufBytes(bufLeft)=w \ 256
      bufLeft=bufLeft+1
    Next
  Else
    For n=Len(buf) To 1 Step -1
      c=Mid(buf,n,1)
      w=AscW(c)
      If w<0 Then
        w=w+256*256
      End If
      bufBytes(bufLeft)=w \ 256
      bufLeft=bufLeft+1
      bufBytes(bufLeft)=w mod 256
      bufLeft=bufLeft+1
    Next
  End If
  FilBuf=bufLeft
End Function

Function Read(n)
  Dim i,c,u
  Dim bytes()
  
  u=n-1
  Redim bytes(u)
  i=-1
  Do While i<u
    If bufLeft=0 Then
      If file.AtEndOfStream Then Exit Do
      If FilBuf()=0 Then Exit Do
    End If
    bufLeft=bufLeft-1
    i=i+1
    bytes(i)=bufBytes(bufLeft)
  Loop
  If i<u Then
    If Mandatory Then Err.Raise 62
    Redim Preserve bytes(i)
  End If
  Read=bytes
End Function

Function ReadLine()
  Dim c,i,u
  Dim bytes()
  
  u=80
  Redim bytes(u)
  i=-1
  Do While True
    If bufLeft=0 Then
      If file.AtEndOfStream Then Exit Do
      If FilBuf()=0 Then Exit Do
    End If
    bufLeft=bufLeft-1
    c=bufBytes(bufLeft)
    If c=EOLchar Then
      If EOLchop Then Exit Do
      i=i+1
      if i>u Then
        u=i
        Redim Preserve bytes(u)
      End If
      bytes(i)=c
      Exit Do
    End If
    i=i+1
    if i>u Then
      u=u+80
      Redim Preserve bytes(u)
    End If
    bytes(i)=c
  Loop
  if i<u Then
    Redim Preserve bytes(i)
  End If
  ReadLine=bytes
End Function

Function ReadAll()
  Dim buf
  Dim bytes()
  Dim n,i
  Dim c,w
  
  If Not file.AtEndOfStream Then
    buf=file.ReadAll()
    n=Len(buf)
    Redim bytes(n*2-1)
    For i=0 To n-1
      c=Mid(buf,1+i,1)
      w=AscW(c)
      If w<0 Then
        w=w+256*256
      End If
      bytes(i*2)=w mod 256
      bytes(i*2+1)=w \ 256
    Next
  End If
  ReadAll=bytes
End Function

Function Close()
  file.close()
End Function

End Class

Function String2Bytes(str)
  Dim n,i
  Dim bytes()

  n=Len(str)
  ReDim bytes(n-1)
  For i=0 To n-1
    bytes(i)=Asc(Mid(str,1+i,1))
  Next
  String2Bytes=bytes
End Function

Function MidBytes(a,s,n)
  Dim bytes()
  Dim i
  If n<=0 Then n=UBound(a)-s+1
  ReDim bytes(n-1)
  For i=0 To n-1
    bytes(i)=a(s+i)
  Next
  MidBytes=bytes
End Function

Function CatBytes(a,b)
  Dim bytes()
  Dim n,i
  n=UBound(a)+UBound(b)+1
  ReDim bytes(n)
  For i=0 To UBound(a)
    bytes(i)=a(i)
  Next
  n=UBound(a)
  For i=0 To UBound(b)
    n=n+1
    bytes(n)=b(i)
  Next
  CatBytes=bytes
End Function

Function Bytes2Hex(a,s,n)
  Dim h,i
  If n<=0 Then n=UBound(a)-s+1
  For i=0 To n-1
    h=h & Right("0" & Hex(a(s+i)),2)
  Next
  Bytes2Hex=h
End Function

Function Bytes2String(a,s,n)
  Dim r,i
  If n<=0 Then n=UBound(a)-s+1
  For i=0 To n-1
    r=r & Chr(a(s+i))
  Next
  Bytes2String=r
End Function

